﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 팝업 폼
    /// </summary>
    public partial class PopupForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 열 카운트
        /// </summary>
        private const int COLUMN_COUNT = 10;

        /// <summary>
        /// 행 카운트
        /// </summary>
        private const int ROW_COUNT = 10;

        /// <summary>
        /// 난수 발생기
        /// </summary>
        private Random random = new Random();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - PopupForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public PopupForm()
        {
            InitializeComponent();

            #region 데이터 그리드 뷰 컨트롤을 설정한다.

            ControlHelper.SetDoubleBuffering(this.dataGridView, true);

            for(int i = 0; i < COLUMN_COUNT; i++)
            {
                this.dataGridView.Columns.Add(i.ToString(), i.ToString());
            }

            this.dataGridView.RowCount = ROW_COUNT;

            #endregion
            #region 이벤트를 설정한다.

            this.timer1.Tick += timer_Tick;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 폼 닫기 - CloseForm()

        /// <summary>
        /// 폼 닫기
        /// </summary>
        public void CloseForm()
        {
            if(InvokeRequired)
            {
                Invoke(new Action(delegate { CloseForm(); }));
            }
            else
            {
                Close();
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 타이머 틱 처리하기 - timer_Tick(sender, e)

        /// <summary>
        /// 타이머 틱 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void timer_Tick(object sender, EventArgs e)
        {
            for(int i = 0; i < COLUMN_COUNT; i++)
            {
                for(int j = 0; j < ROW_COUNT; j++)
                {
                    this.dataGridView.Rows[j].Cells[i].Value = this.random.Next(0, 100).ToString();
                }
            }
        }

        #endregion
    }
}